// Copyright (C) 1999-2000 Jean-Marc Valin

#define STUPID_COMPLEX_KLUDGE

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <GLSpectrum.h>
#include <stdlib.h>
#include "FFTWrap.h"
#include <math.h>
#include <gnome.h>

static void set_interpolate (GtkCheckMenuItem *item, GLSpectrum *spectrum)
{
}

static void set_color (GtkCheckMenuItem *item, GLSpectrum *spectrum)
{
   spectrum->setColor(item->active);
}

static void spectrum_remove (GtkMenuItem *item, GLSpectrum *spectrum)
{
}

GLSpectrum::GLSpectrum(SourceManager *_sources)
   : GLPlot(_sources)
   , color(false)
{
   menu = gtk_menu_new();
   gtk_widget_show(menu);


   GtkWidget *label = gtk_check_menu_item_new_with_label(_("Interpolate"));
   gtk_object_ref(GTK_OBJECT(label));
   gtk_object_set_data_full (GTK_OBJECT (menu), "label1",
                             label,
                             (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show(label);
   gtk_menu_append(GTK_MENU(menu),label);
   gtk_signal_connect (GTK_OBJECT (label), "toggled",
                       GTK_SIGNAL_FUNC (set_interpolate),
                       this);
   
   label = gtk_check_menu_item_new_with_label(_("Color"));
   gtk_object_ref(GTK_OBJECT(label));
   gtk_object_set_data_full (GTK_OBJECT (menu), "label2",
                             label,
                             (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show(label);
   gtk_menu_append(GTK_MENU(menu),label);
   gtk_signal_connect (GTK_OBJECT (label), "toggled",
                       GTK_SIGNAL_FUNC (set_color),
                       this);
   
   label = gtk_menu_item_new_with_label(_("Remove"));
   gtk_object_ref(GTK_OBJECT(label));
   gtk_object_set_data_full (GTK_OBJECT (menu), "label3",
                             label,
                             (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show(label);
   gtk_menu_append(GTK_MENU(menu),label);
   gtk_signal_connect (GTK_OBJECT (label), "activate",
                       GTK_SIGNAL_FUNC (spectrum_remove),
                       this);
   
   gnome_popup_menu_attach(menu, glarea, this);
   

   
}

GLSpectrum::~GLSpectrum()
{
   gtk_widget_destroy(menu);
}



void GLSpectrum::plot()
{
   float in[256];
   float out[256];
   float window[256];
   int i;
   float RGBMap[256][3];
   //bool color = false;
   if (color)
   { /* generate colorscale in color */
      for (i=0;i<32;i++)
      {
         RGBMap[i][0]=0.0;
         RGBMap[i][1]=0.0;
         RGBMap[i][2]=.5 + .5*i/32.0;
      }
      for (i=32;i<96;i++)
      {
         RGBMap[i][0]=0.0;
         RGBMap[i][1]=(i-32)/64.0;
         RGBMap[i][2]=1;
      }
      for (i=96;i<160;i++)
      {
         RGBMap[i][0]=(i-96)/64.0;
         RGBMap[i][1]=1.0;
         RGBMap[i][2]=1.0-(i-96)/64.0;      
      }
      for (i=160;i<224;i++)
      {
         RGBMap[i][0]=1;
         RGBMap[i][1]=(1-(i-160)/64.0);
         RGBMap[i][2]=0;      
      }
      for (i=224;i<256;i++)
      {
         RGBMap[i][0]=1 - .5*(i-224)/32.0;
         RGBMap[i][1]=0;
         RGBMap[i][2]=0;      
      }
   } else { /* generate colorscale in black and white */
      for (i=0;i<256;i++)
         RGBMap[i][0]=RGBMap[i][1]=RGBMap[i][2]=1.0-i/255.0;
   }




   for (int i=0;i<256;i++)
   {
      window[i] = .5 - .5*cos(2*M_PI*i/256.0);
   }

   int nbPlots = sources->size();
   
   for (int n=0;n<nbPlots;n++)
   {
      int nbFrames = ((*sources)[n]->getLength()) / 256 - 1;
      //cerr << "nb frames = " << nbFrames << endl;
      float spectrum[nbFrames][128];
      float sp_min=FLT_MAX, sp_max=-FLT_MAX;
      double mean=0, sd=0;
      for (int i=0;i<nbFrames;i++)
      {
	 (*sources)[n]->getData(i*256, 256, in);
	 for (int j=0;j<256;j++)
	    in[j] *= window[j];

	 FFTWrap.rfft(in, out, 256);
	 
	 {
	    float tmp = log(100 + out[0]*out[0]);
	    spectrum[i][0] = tmp;
	    sp_max = tmp > sp_max ? tmp : sp_max;
	    sp_min = tmp < sp_min ? tmp : sp_min;
	 }
	 for (int j=1;j<128;j++)
	 {
	    float tmp = log(100 + out[j]*out[j] + out[256-j]*out[256-j]);
	    spectrum[i][j] = tmp;
	    sp_max = tmp > sp_max ? tmp : sp_max;
	    sp_min = tmp < sp_min ? tmp : sp_min;
	    mean+=tmp;
	    sd+=tmp*tmp;
	 }
      }
      if (sp_min< sp_max-17)
	 sp_min = sp_max-17;
      for (int i=0;i<nbFrames;i++)
	 for (int j=0;j<128;j++)
	    if (spectrum[i][j]<sp_min)
	       spectrum[i][j]=sp_min;

      mean /= 127*nbFrames;
      sd = sqrt(sd/(127*nbFrames) - mean*mean);
      //sp_min = mean-1*sd;
      //sp_max = mean+1.5*sd;
      float scaling = 1/(.000001+sp_max-sp_min);
      for (int i=0;i<nbFrames;i++)
	 for (int j=0;j<128;j++)
	    spectrum[i][j] = scaling * (spectrum[i][j]-sp_min);
      //cerr << sp_min << " to " << sp_max << endl;
      glBegin(GL_QUADS);
      float xscale = 2.0/(nbFrames-1);
      float yscale = 2.0/127.0/float(nbPlots);
      float yoffset = -1 + 2*n/float(nbPlots);
      for (int i=0;i<nbFrames-1;i++)
	 for (int j=0;j<127;j++)
	 {
	    //glColor3f(1-spectrum[i][j], 1-spectrum[i][j], 1-spectrum[i][j]);
	    glColor3fv(RGBMap[int(255*spectrum[i][j])]);
	    glVertex2f( xscale*i - 1 , yscale*j + yoffset);

	    //glColor3f(1-spectrum[i+1][j], 1-spectrum[i+1][j], 1-spectrum[i+1][j]);
	    glColor3fv(RGBMap[int(255*spectrum[i+1][j])]);
	    glVertex2f( xscale*(i+1) - 1 , yscale*j + yoffset);

	    //glColor3f(1-spectrum[i+1][j+1], 1-spectrum[i+1][j+1], 1-spectrum[i+1][j+1]);
	    glColor3fv(RGBMap[int(255*spectrum[i+1][j+1])]);
	    glVertex2f( xscale*(i+1) - 1 , yscale*(j+1) + yoffset);

	    //glColor3f(1-spectrum[i][j+1], 1-spectrum[i][j+1], 1-spectrum[i][j+1]);
	    glColor3fv(RGBMap[int(255*spectrum[i][j+1])]);
	    glVertex2f( xscale*i - 1 , yscale*(j+1) + yoffset);

	 }
      glEnd();
   }

}
